'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.load = undefined;

let load = exports.load = (() => {
  var _ref2 = _asyncToGenerator(function* (name, spinfile) {
    const task = spinfile[name];

    if ((0, _helpers.isFunction)(task)) {
      return Promise.resolve(wrap(task));
    }

    return Promise.reject(`Task '${ name }' not found.`);
  });

  return function load(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
})();

var _streamToPromise = require('stream-to-promise');

var _streamToPromise2 = _interopRequireDefault(_streamToPromise);

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function wrap(task) {
  return {
    name: task.name,
    run: (() => {
      var _ref = _asyncToGenerator(function* (options) {
        // Handle task with callback
        if (task.length === 2) {
          return (0, _helpers.promisify)(task)(options);
        }

        // Handle task with both async and promise
        const result = yield task(options);

        // Handle task with stream
        if ((0, _helpers.isStream)(result)) {
          return (0, _streamToPromise2.default)(result);
        }

        return result;
      });

      return function run(_x) {
        return _ref.apply(this, arguments);
      };
    })()
  };
}

exports.default = {
  load
};
//# sourceMappingURL=loader.js.map