'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.runner = exports.run = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

let run = exports.run = (() => {
  var _ref = _asyncToGenerator(function* (task, options) {
    const timer = new _helpers.Timer();

    _logger2.default.time(`Starting '${ task.name }'...`);
    const result = yield task.run(options);
    _logger2.default.time(`Finished '${ task.name }' in ${ timer.stop().getTotalTimeInSec() }s`);

    return result;
  });

  return function run(_x, _x2) {
    return _ref.apply(this, arguments);
  };
})();

let runner = exports.runner = (() => {
  var _ref2 = _asyncToGenerator(function* (spinfile, argv) {
    let sequence = (() => {
      var _ref3 = _asyncToGenerator(function* (tasks) {
        return tasks.reduce(function (last, name) {
          return last.then(function () {
            return (0, _loader.load)(name, spinfile).then(function (task) {
              return run(task, _extends({}, argv));
            });
          });
        }, Promise.resolve());
      });

      return function sequence(_x5) {
        return _ref3.apply(this, arguments);
      };
    })();

    let parallel = (() => {
      var _ref4 = _asyncToGenerator(function* (tasks) {
        yield Promise.all(tasks.map((() => {
          var _ref5 = _asyncToGenerator(function* (name) {
            if (name.indexOf('+')) {
              yield sequence(name.split('+'));
            } else {
              const task = yield (0, _loader.load)(name, spinfile);
              yield run(task, _extends({}, argv));
            }
          });

          return function (_x7) {
            return _ref5.apply(this, arguments);
          };
        })()));
      });

      return function parallel(_x6) {
        return _ref4.apply(this, arguments);
      };
    })();

    const tasks = argv._ || [];
    if (tasks.length === 0) {
      tasks[0] = 'default';
    }

    const timer = new _helpers.Timer();
    if (argv.p || argv.parallel) {
      yield parallel(tasks);
    } else {
      yield sequence(tasks);
    }

    _logger2.default.log(`✨  Done in ${ timer.stop().getTotalTimeInSec() }s`);
  });

  return function runner(_x3, _x4) {
    return _ref2.apply(this, arguments);
  };
})();

var _logger = require('./logger');

var _logger2 = _interopRequireDefault(_logger);

var _loader = require('./loader');

var _helpers = require('./helpers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = {
  runner
};
//# sourceMappingURL=runner.js.map